local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

a.Rotations = {}
s.Spam[AddonName] = function()
    c.Flash(a)
end

a.Rotations.Assassination = {
    Spec = 1,
    OffSwitch = "assassination_off",
    
    FlashInCombat = function()
        a.FlashAll(
            "Vendetta",
            "Vanish for Assassination",
            "Tricks of the Trade",
            "Kick")
        local snd = c.GetBuffDuration("Slice and Dice")
        if snd > .1 and snd < 3 then
            a.Flash("Envenom")
        else
            a.Flash(
                "Slice and Dice",
                "Rupture for Assassination",
                "Smart Envenom",
                "Backstab during Execute",
                "Mutilate")
        end
    end,
    
    FlashOutOfCombat = function()
        if a.InSoloMode() then
            a.Flash("Recuperate")
        end
    end,
    
    FlashAlways = function()
        a.FlashAll("Deadly Poison", "Instant Poison")
    end,
}

a.Rotations.Combat = {
    Spec = 2,
    OffSwitch = "combat_off",
        
    FlashInCombat = function()
        a.Flash("Tricks of the Trade", "Kick")
        c.RotateCooldowns({}, "Adrenaline Rush", "Killing Spree")
        a.Flash(
            "Slice and Dice",
            "Expose Armor",
            "Rupture unless SnD",
            "Eviscerate for Combat",
            "Revealing Strike",
            "Sinister Strike Smart")
    end,
    
    FlashOutOfCombat = function()
        if a.InSoloMode() then
            a.Flash("Recuperate")
        end
    end,
    
    FlashAlways = function()
        a.FlashAll("Deadly or Wound", "Instant or Wound")
    end,
}

a.Rotations.Subtlety = {
    Spec = 3,
    OffSwitch = "sub_off",
    
    FlashInCombat = function()
        a.Flash("Premeditation", "Tricks of the Trade", "Kick")
        local untilCap =
            s.PowerMissing("player") - a.GetRegen() * c.GetBusyTime()
        local nextCool = math.min(
            c.GetCooldown("Shadow Dance"), c.GetCooldown("Vanish"))
        if c.HasBuff("Master of Subtlety") or c.HasBuff("Find Weakness") then
            nextCool = 500
        end
        
        if untilCap < 10 then
            a.Flash("Shadow Dance", "Vanish for Subtlety")
        end
        
        
        local cp = GetComboPoints("player")
        if (cp < 4 and nextCool > 7)
            or (cp < 5 and (
                untilCap < 5
                    or a.InSoloMode()
                    or not s.HasTalent(51701))) then -- Honor Among Thieves
            
            a.Flash("Shadowstep")
            a.Flash(
                "Ambush",
                "Hemorrhage",
                "Backstab",
                "Preparation")
        elseif cp == 5 then
            a.Flash(
                "Rupture with Master of Subtlety",
                "Slice and Dice unless Solo",
                "Rupture for Subtlety",
                "Recuperate for Energetic Recovery",
                "Eviscerate for Subtlety",
                "Preparation")
        end
    end,
    
    FlashOutOfCombat = function()
        if a.InSoloMode() then
            a.Flash("Recuperate")
        end
    end,
    
    FlashAlways = function()
        a.FlashAll("Deadly or Wound", "Instant or Wound")
    end,
}
